#ifndef sys_time_h
/*
* This is probably the single  most  confusing  system  header-file  mess  for
* people  trying to write portable code.  You WILL have to change this one for
* your system! At a very minimum, the V package requires the tm and  timeval
* structures, and there is no agreement among vendors as to where these should
* be defined.  If you need more time-related stuff,  add  to  the  appropriate
* entry here, and don't worry about updating the others, since you don't stand
* a chance of guessing correctly for all those systems.
*/
#if	!defined(sys_time_h) && (defined(ULTRIX) || defined(BSD))
#include	<time.h>	/* BSD-style clock handling */
#include	<sys/time.h>
/*#include	<utime.h> */
#define sys_time_h
#endif
/*
* Tandem is one of the worst cases I've seen so far:
*/
#if	!defined(sys_time_h) && defined(TNV3)
#include	"/usr/include/time.h"
#include	"/usr/include/bsd/sys/time.h"
#include	"/usr/include/bsd/sys/utime.h"
#ifndef _sys_timeval_h_
#include	"/usr/include/sys/timeval.h"
#endif
#define sys_time_h
#endif
/*
* The Sys/V derivatives usually require two time.h files; they contain
* different  definitions.   SunOS has copied this distinction.  We can
* expect POSIX systems to be similar.
*/
#if	!defined(sys_time_h) && (defined(SYS5) || defined(SUN4) || defined(AIX3))
#include	<time.h>		/* struct tm defined here */
#include	<sys/time.h>	/* struct timeval defined here */
#include	<utime.h>		/* struct utimbuf defined here */
#define sys_time_h
#endif
/*
* The generic BSD systems do it all from one file, which  has  several
* names.   It generally isn't safe to include all of them, but any one
* will do.  Note that this does NOT work for Suns.
*/
#if	!defined(sys_time_h) && (defined(ULTRIX) || defined(BSD))
#include	<time.h>	/* BSD-style clock handling */
#include	<utime.h>	/* BSD-style clock handling */
#define sys_time_h
#endif
/*
* If none of the above succeeded, here's a last  attempt.   This  will
* only  work  if both these files exist and are different, or they are
* properly protected with #ifndef.
*/
#if	!defined(sys_time_h)
#include	<time.h>		/* struct tm defined here */
#include	<sys/time.h>	/* struct timeval defined here */
#include	<utime.h>		/* struct utimbuf defined here */
#define sys_time_h
#endif
/*
* Some handy abbreviations for lazy typists:
*/
#ifndef TIMV	/*	Unix microsecond timer structure */
#define TIMV struct timeval
#endif
#ifndef TIMZ	/*	Unix timezone structure */
#define TIMZ struct timezone
#endif

/*
* Some macros for manipulating TIMV structs:
*/
#define TimeGT(t1,t2) \
	(((t1).tv_sec > (t2).tv_sec) || (((t1).tv_sec == (t2).tv_sec) && ((t1).tv_usec > (t2).tv_usec)))
#define TimeLT(t1,t2) \
	(((t1).tv_sec < (t2).tv_sec) || (((t1).tv_sec == (t2).tv_sec) && ((t1).tv_usec < (t2).tv_usec)))
#define TimeFlds(t) (t).tv_sec,(t).tv_usec
#define TimeSpec(t) (t).tv_sec,(t).tv_nsec

#endif
